Index: soft/giet_vm/applications/transpose/transpose.c
===================================================================
--- soft/giet_vm/applications/transpose/transpose.c	(revision 772)
+++ soft/giet_vm/applications/transpose/transpose.c	(revision 775)
@@ -47,9 +47,9 @@
 #define PROCS_MAX             4                            // max number of procs per cluster
 #define CLUSTER_MAX           (X_MAX * Y_MAX)              // max number of clusters
-#define IMAGE_SIZE            256                          // default image size 
-#define INPUT_FILE_PATH       "/misc/lena_256.raw"         // default input file pathname 
-#define OUTPUT_FILE_PATH      "/home/lena_transposed.raw"  // default output file pathname 
+#define IMAGE_SIZE            128                          // default image size 
+#define INPUT_FILE_PATH       "/misc/images_128.raw"       // default input file pathname 
+#define OUTPUT_FILE_PATH      "/home/trsp_128.raw"         // default output file pathname 
 #define INTERACTIVE           0                            // interactive capture of filenames 
-#define VERBOSE               1                            // print comments on TTY
+#define VERBOSE               0                            // print comments on TTY
 
 
@@ -126,5 +126,5 @@
     if ( p_id == 0 ) 
     {
-        // map buf_in and buf_out
+        // map buf_in
         unsigned int length = npixels / nclusters;
         unsigned int offset = length * cluster_id;
@@ -144,8 +144,11 @@
                  
         if ( VERBOSE )
-        printf("\n@@@ Thread[%d,%d,%d] call mmap for input file\n"
-               " length = %x / offset = %x / buf_in = %x\n",
-               x_id , y_id , p_id , length , offset , buf_in[cluster_id] );
-           
+        {
+            printf("\n@@@ Thread[%d,%d,%d] call mmap for input file\n"
+                   " length = %x / offset = %x / buf_in = %x\n",
+                   x_id , y_id , p_id , length , offset , buf_in[cluster_id] );
+        }
+
+        // map buf_out           
         buf_out[cluster_id] = giet_fat_mmap( NULL,
                                              length,
@@ -154,4 +157,5 @@
                                              fd_out,
                                              offset );
+
         if ( buf_out[cluster_id] == NULL )
         {
@@ -162,7 +166,9 @@
                    
         if ( VERBOSE )
-        printf("\n@@@ Thread[%d,%d,%d] call mmap for output file\n"
-               " length = %x / offset = %x / buf_out = %x\n",
-               x_id , y_id , p_id , length , offset , buf_out[cluster_id] );
+        {
+            printf("\n@@@ Thread[%d,%d,%d] call mmap for output file\n"
+                   " length = %x / offset = %x / buf_out = %x\n",
+                   x_id , y_id , p_id , length , offset , buf_out[cluster_id] );
+        }
        
     }
@@ -275,9 +281,13 @@
     unsigned int max_disp_ended = 0;
  
+    char string[64];
+
+    snprintf( string , 64 , "/home/transpose_%d_%d_%d" , x_size , y_size , nprocs );
+
     // open instrumentation file
-    unsigned int fd = giet_fat_open( "/home/transpose.inst" , O_CREAT);
+    unsigned int fd = giet_fat_open( string , O_CREATE );
     if ( fd < 0 ) 
     { 
-        printf("\n[TRANSPOSE ERROR] main cannot open file transpose.inst\n");
+        printf("\n[TRANSPOSE ERROR] cannot open instrumentation file %s\n", string );
         giet_pthread_exit( NULL );
     }
@@ -305,47 +315,54 @@
     }
 
-    printf("\n   ---------------- Instrumentation Results ---------------------\n");
-
-    printf(" - MMAP_START : min = %d / max = %d / med = %d / delta = %d\n",
+    giet_tty_printf( "\n ------ %s ------\n" , string );
+    giet_fat_fprintf( fd , "\n ------ %s ------\n" , string );
+
+    giet_tty_printf( " - MMAP_START : min = %d / max = %d / med = %d / delta = %d\n",
            min_load_start, max_load_start, (min_load_start+max_load_start)/2, 
-           max_load_start-min_load_start); 
+           max_load_start-min_load_start ); 
+
     giet_fat_fprintf( fd , " - MMAP_START : min = %d / max = %d / med = %d / delta = %d\n",
            min_load_start, max_load_start, (min_load_start+max_load_start)/2, 
-           max_load_start-min_load_start); 
-
-    printf(" - MMAP_END   : min = %d / max = %d / med = %d / delta = %d\n",
+           max_load_start-min_load_start ); 
+
+    giet_tty_printf( " - MMAP_END   : min = %d / max = %d / med = %d / delta = %d\n",
            min_load_ended, max_load_ended, (min_load_ended+max_load_ended)/2, 
-           max_load_ended-min_load_ended); 
+           max_load_ended-min_load_ended ); 
+
     giet_fat_fprintf( fd , " - MMAP_END   : min = %d / max = %d / med = %d / delta = %d\n",
            min_load_ended, max_load_ended, (min_load_ended+max_load_ended)/2, 
-           max_load_ended-min_load_ended); 
-
-    printf(" - TRSP_START : min = %d / max = %d / med = %d / delta = %d\n",
+           max_load_ended-min_load_ended ); 
+
+    giet_tty_printf( " - TRSP_START : min = %d / max = %d / med = %d / delta = %d\n",
            min_trsp_start, max_trsp_start, (min_trsp_start+max_trsp_start)/2, 
-           max_trsp_start-min_trsp_start); 
+           max_trsp_start-min_trsp_start ); 
+
     giet_fat_fprintf( fd , " - TRSP_START : min = %d / max = %d / med = %d / delta = %d\n",
            min_trsp_start, max_trsp_start, (min_trsp_start+max_trsp_start)/2, 
-           max_trsp_start-min_trsp_start); 
-
-    printf(" - TRSP_END   : min = %d / max = %d / med = %d / delta = %d\n",
+           max_trsp_start-min_trsp_start ); 
+
+    giet_tty_printf( " - TRSP_END   : min = %d / max = %d / med = %d / delta = %d\n",
            min_trsp_ended, max_trsp_ended, (min_trsp_ended+max_trsp_ended)/2, 
-           max_trsp_ended-min_trsp_ended); 
+           max_trsp_ended-min_trsp_ended ); 
+
     giet_fat_fprintf( fd , " - TRSP_END   : min = %d / max = %d / med = %d / delta = %d\n",
            min_trsp_ended, max_trsp_ended, (min_trsp_ended+max_trsp_ended)/2, 
-           max_trsp_ended-min_trsp_ended); 
-
-    printf(" - DISP_START : min = %d / max = %d / med = %d / delta = %d\n",
+           max_trsp_ended-min_trsp_ended ); 
+
+    giet_tty_printf( " - DISP_START : min = %d / max = %d / med = %d / delta = %d\n",
            min_disp_start, max_disp_start, (min_disp_start+max_disp_start)/2, 
-           max_disp_start-min_disp_start); 
+           max_disp_start-min_disp_start ); 
+
     giet_fat_fprintf( fd , " - DISP_START : min = %d / max = %d / med = %d / delta = %d\n",
            min_disp_start, max_disp_start, (min_disp_start+max_disp_start)/2, 
-           max_disp_start-min_disp_start); 
-
-    printf(" - DISP_END   : min = %d / max = %d / med = %d / delta = %d\n",
+           max_disp_start-min_disp_start ); 
+
+    giet_tty_printf( " - DISP_END   : min = %d / max = %d / med = %d / delta = %d\n",
            min_disp_ended, max_disp_ended, (min_disp_ended+max_disp_ended)/2, 
-           max_disp_ended-min_disp_ended); 
+           max_disp_ended-min_disp_ended ); 
+
     giet_fat_fprintf( fd , " - DISP_END   : min = %d / max = %d / med = %d / delta = %d\n",
            min_disp_ended, max_disp_ended, (min_disp_ended+max_disp_ended)/2, 
-           max_disp_ended-min_disp_ended); 
+           max_disp_ended-min_disp_ended ); 
 
     giet_fat_close( fd );
@@ -453,5 +470,5 @@
     }
 
-    fd_out = giet_fat_open( output_file_name , O_CREAT);   // create if required
+    fd_out = giet_fat_open( output_file_name , O_CREATE );   // create if required
     if ( fd_out < 0 ) 
     { 