Index: trunk/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- trunk/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 729)
+++ trunk/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 779)
@@ -880,51 +880,57 @@
                 << "[001] NUMBER OF CYCLES          = " << m_cpt_cycles << std::endl
                 << std::endl
-                << "[002] LOCAL READ                = " << m_cpt_read_local << std::endl
-                << "[003] REMOTE READ               = " << m_cpt_read_remote << std::endl
-                << "[004] READ COST (FLITS * DIST)  = " << m_cpt_read_cost << std::endl
+                << "[010] LOCAL READ                = " << m_cpt_read_local << std::endl
+                << "[011] REMOTE READ               = " << m_cpt_read_remote << std::endl
+                << "[012] READ COST (FLITS * DIST)  = " << m_cpt_read_cost << std::endl
                 << std::endl
-                << "[005] LOCAL WRITE               = " << m_cpt_write_local << std::endl
-                << "[006] REMOTE WRITE              = " << m_cpt_write_remote << std::endl
-                << "[007] WRITE FLITS LOCAL         = " << m_cpt_write_flits_local << std::endl
-                << "[008] WRITE FLITS REMOTE        = " << m_cpt_write_flits_remote << std::endl
-                << "[009] WRITE COST (FLITS * DIST) = " << m_cpt_write_cost << std::endl
+                << "[020] LOCAL WRITE               = " << m_cpt_write_local << std::endl
+                << "[021] REMOTE WRITE              = " << m_cpt_write_remote << std::endl
+                << "[022] WRITE FLITS LOCAL         = " << m_cpt_write_flits_local << std::endl
+                << "[023] WRITE FLITS REMOTE        = " << m_cpt_write_flits_remote << std::endl
+                << "[024] WRITE COST (FLITS * DIST) = " << m_cpt_write_cost << std::endl
+                << "[025] WRITE L1 MISS NCC         = " << "0" << std::endl
                 << std::endl
-                << "[010] LOCAL LL                  = " << m_cpt_ll_local << std::endl
-                << "[011] REMOTE LL                 = " << m_cpt_ll_remote << std::endl
-                << "[012] LL COST (FLITS * DIST)    = " << m_cpt_ll_cost << std::endl
+                << "[030] LOCAL LL                  = " << m_cpt_ll_local << std::endl
+                << "[031] REMOTE LL                 = " << m_cpt_ll_remote << std::endl
+                << "[032] LL COST (FLITS * DIST)    = " << m_cpt_ll_cost << std::endl
                 << std::endl
-                << "[013] LOCAL SC                  = " << m_cpt_sc_local << std::endl
-                << "[014] REMOTE SC                 = " << m_cpt_sc_remote << std::endl
-                << "[015] SC COST (FLITS * DIST)    = " << m_cpt_sc_cost << std::endl
+                << "[040] LOCAL SC                  = " << m_cpt_sc_local << std::endl
+                << "[041] REMOTE SC                 = " << m_cpt_sc_remote << std::endl
+                << "[042] SC COST (FLITS * DIST)    = " << m_cpt_sc_cost << std::endl
                 << std::endl
-                << "[016] LOCAL CAS                 = " << m_cpt_cas_local << std::endl
-                << "[017] REMOTE CAS                = " << m_cpt_cas_remote << std::endl
-                << "[018] CAS COST (FLITS * DIST)   = " << m_cpt_cas_cost << std::endl
+                << "[050] LOCAL CAS                 = " << m_cpt_cas_local << std::endl
+                << "[051] REMOTE CAS                = " << m_cpt_cas_remote << std::endl
+                << "[052] CAS COST (FLITS * DIST)   = " << m_cpt_cas_cost << std::endl
                 << std::endl
-                << "[019] REQUESTS TRIG. UPDATE     = " << m_cpt_update << std::endl
-                << "[020] LOCAL UPDATE              = " << m_cpt_update_local << std::endl
-                << "[021] REMOTE UPDATE             = " << m_cpt_update_remote << std::endl
-                << "[022] UPDT COST (FLITS * DIST)  = " << m_cpt_update_cost << std::endl
+                << "[060] REQUESTS TRIG. UPDATE     = " << m_cpt_update << std::endl
+                << "[061] LOCAL UPDATE              = " << m_cpt_update_local << std::endl
+                << "[062] REMOTE UPDATE             = " << m_cpt_update_remote << std::endl
+                << "[063] UPDT COST (FLITS * DIST)  = " << m_cpt_update_cost << std::endl
                 << std::endl
-                << "[023] REQUESTS TRIG. M_INV      = " << m_cpt_minval << std::endl
-                << "[024] LOCAL M_INV               = " << m_cpt_minval_local << std::endl
-                << "[025] REMOTE M_INV              = " << m_cpt_minval_remote << std::endl
-                << "[026] M_INV COST (FLITS * DIST) = " << m_cpt_minval_cost << std::endl
+                << "[070] REQUESTS TRIG. M_INV      = " << m_cpt_minval << std::endl
+                << "[071] LOCAL M_INV               = " << m_cpt_minval_local << std::endl
+                << "[072] REMOTE M_INV              = " << m_cpt_minval_remote << std::endl
+                << "[073] M_INV COST (FLITS * DIST) = " << m_cpt_minval_cost << std::endl
                 << std::endl
-                << "[027] BROADCAT INVAL            = " << m_cpt_binval << std::endl
+                << "[080] BROADCAT INVAL            = " << m_cpt_binval << std::endl
+                << "[081] WRITE BROADCAST           = " << m_cpt_write_broadcast << std::endl
                 << std::endl
-                << "[028] LOCAL CLEANUP             = " << m_cpt_cleanup_local << std::endl
-                << "[029] REMOTE CLEANUP            = " << m_cpt_cleanup_remote << std::endl
-                << "[030] CLNUP COST (FLITS * DIST) = " << m_cpt_cleanup_cost << std::endl
+                << "[090] LOCAL CLEANUP             = " << m_cpt_cleanup_local << std::endl
+                << "[091] REMOTE CLEANUP            = " << m_cpt_cleanup_remote << std::endl
+                << "[092] CLNUP COST (FLITS * DIST) = " << m_cpt_cleanup_cost << std::endl
+                << "[093] CLEANUP DATA              = " << "0" << std::endl
                 << std::endl
+                << "[100] READ MISS                 = " << m_cpt_read_miss << std::endl
+                << "[101] WRITE MISS                = " << m_cpt_write_miss << std::endl
+                << "[102] WRITE DIRTY               = " << m_cpt_write_dirty << std::endl
                 << std::endl
-                << "[031] READ MISS                 = " << m_cpt_read_miss << std::endl
-                << "[032] WRITE MISS                = " << m_cpt_write_miss << std::endl
-                << "[033] WRITE DIRTY               = " << m_cpt_write_dirty << std::endl
-                << "[034] RD BLOCKED BY HIT IN TRT  = " << m_cpt_trt_rb << std::endl
-                << "[035] TRANS BLOCKED BY FULL TRT = " << m_cpt_trt_full << std::endl
-                << "[036] PUT (UNIMPLEMENTED)       = " << m_cpt_put << std::endl
-                << "[037] GET (UNIMPLEMENTED)       = " << m_cpt_get << std::endl
-                << "[038] WRITE BROADCAST           = " << m_cpt_write_broadcast << std::endl
+                << "[110] RD BLOCKED BY HIT IN TRT  = " << m_cpt_trt_rb << std::endl
+                << "[111] TRANS BLOCKED BY FULL TRT = " << m_cpt_trt_full << std::endl
+                << "[120] PUT (UNIMPLEMENTED)       = " << m_cpt_put << std::endl
+                << "[121] GET (UNIMPLEMENTED)       = " << m_cpt_get << std::endl
+                << "[130] MIN HEAP SLOT AV. (UNIMP) = " << "0" << std::endl
+                << std::endl;
+                << "[140] NCC TO CC (READ)          = " << "0" << std::endl
+                << "[141] NCC TO CC (WRITE)         = " << "0" << std::endl
                 << std::endl;
         }
@@ -935,45 +941,45 @@
             std::cout << "----------------------------------" << std::dec << std::endl;
             std::cout
-                << "[100] READ TOTAL            = " << m_cpt_read_local + m_cpt_read_remote << std::endl
-                << "[101] READ RATE             = " << (double) (m_cpt_read_local + m_cpt_read_remote) / m_cpt_cycles << std::endl
-                << "[102] LOCAL READ RATE       = " << (double) m_cpt_read_local / m_cpt_cycles << std::endl
-                << "[103] REMOTE READ RATE      = " << (double) m_cpt_read_remote / m_cpt_cycles << std::endl
-                << "[104] READ MISS RATE        = " << (double) m_cpt_read_miss / (m_cpt_read_local + m_cpt_read_remote) << std::endl
+                << "[300] READ TOTAL            = " << m_cpt_read_local + m_cpt_read_remote << std::endl
+                << "[301] READ RATE             = " << (double) (m_cpt_read_local + m_cpt_read_remote) / m_cpt_cycles << std::endl
+                << "[302] LOCAL READ RATE       = " << (double) m_cpt_read_local / m_cpt_cycles << std::endl
+                << "[303] REMOTE READ RATE      = " << (double) m_cpt_read_remote / m_cpt_cycles << std::endl
+                << "[304] READ MISS RATE        = " << (double) m_cpt_read_miss / (m_cpt_read_local + m_cpt_read_remote) << std::endl
                 << std::endl
-                << "[105] WRITE TOTAL           = " << m_cpt_write_local + m_cpt_write_remote << std::endl
-                << "[106] WRITE RATE            = " << (double) (m_cpt_write_local + m_cpt_write_remote) / m_cpt_cycles << std::endl
-                << "[107] LOCAL WRITE RATE      = " << (double) m_cpt_write_local / m_cpt_cycles << std::endl
-                << "[108] REMOTE WRITE RATE     = " << (double) m_cpt_write_remote / m_cpt_cycles << std::endl
-                << "[109] WRITE MISS RATE       = " << (double) m_cpt_write_miss / (m_cpt_write_local + m_cpt_write_remote) << std::endl
-                << "[110] WRITE BURST TOTAL     = " << m_cpt_write_flits_local + m_cpt_write_flits_remote << std::endl
-                << "[111] WRITE BURST AVERAGE   = " << (double) (m_cpt_write_flits_local + m_cpt_write_flits_remote) / (m_cpt_write_local + m_cpt_write_remote) << std::endl
-                << "[112] LOCAL WRITE BURST AV. = " << (double) m_cpt_write_flits_local / (m_cpt_write_local + m_cpt_write_remote) << std::endl
-                << "[113] REMOTE WRITE BURST AV = " << (double) m_cpt_write_flits_remote / (m_cpt_write_local + m_cpt_write_remote) << std::endl
+                << "[305] WRITE TOTAL           = " << m_cpt_write_local + m_cpt_write_remote << std::endl
+                << "[306] WRITE RATE            = " << (double) (m_cpt_write_local + m_cpt_write_remote) / m_cpt_cycles << std::endl
+                << "[307] LOCAL WRITE RATE      = " << (double) m_cpt_write_local / m_cpt_cycles << std::endl
+                << "[308] REMOTE WRITE RATE     = " << (double) m_cpt_write_remote / m_cpt_cycles << std::endl
+                << "[309] WRITE MISS RATE       = " << (double) m_cpt_write_miss / (m_cpt_write_local + m_cpt_write_remote) << std::endl
+                << "[310] WRITE BURST TOTAL     = " << m_cpt_write_flits_local + m_cpt_write_flits_remote << std::endl
+                << "[311] WRITE BURST AVERAGE   = " << (double) (m_cpt_write_flits_local + m_cpt_write_flits_remote) / (m_cpt_write_local + m_cpt_write_remote) << std::endl
+                << "[312] LOCAL WRITE BURST AV. = " << (double) m_cpt_write_flits_local / (m_cpt_write_local + m_cpt_write_remote) << std::endl
+                << "[313] REMOTE WRITE BURST AV = " << (double) m_cpt_write_flits_remote / (m_cpt_write_local + m_cpt_write_remote) << std::endl
                 << std::endl
-                << "[114] UPDATE RATE                = " << (double) m_cpt_update / m_cpt_cycles << std::endl
-                << "[115] AV. UPDATE PER UP REQ      = " << (double) (m_cpt_update_local + m_cpt_update_remote) / m_cpt_update << std::endl
-                << "[116] AV. LOC UPDT PER UP REQ    = " << (double) m_cpt_update_local / m_cpt_update << std::endl
-                << "[117] AV. REMOTE UPDT PER UP REQ = " << (double) m_cpt_update_remote / m_cpt_update << std::endl
+                << "[314] UPDATE RATE                = " << (double) m_cpt_update / m_cpt_cycles << std::endl
+                << "[315] AV. UPDATE PER UP REQ      = " << (double) (m_cpt_update_local + m_cpt_update_remote) / m_cpt_update << std::endl
+                << "[316] AV. LOC UPDT PER UP REQ    = " << (double) m_cpt_update_local / m_cpt_update << std::endl
+                << "[317] AV. REMOTE UPDT PER UP REQ = " << (double) m_cpt_update_remote / m_cpt_update << std::endl
                 << std::endl
-                << "[118] INVAL MULTICAST RATE  = " << (double) m_cpt_minval / m_cpt_cycles << std::endl
-                << "[119] AVE. INVAL PER M_INV  = " << (double) (m_cpt_minval_local + m_cpt_minval_remote) / m_cpt_minval << std::endl
-                << "[120] AV. LOC INV PER M_INV = " << (double) m_cpt_minval_local / m_cpt_minval << std::endl
-                << "[121] AV. REM INV PER M_INV = " << (double) m_cpt_minval_remote / m_cpt_minval << std::endl
+                << "[318] INVAL MULTICAST RATE  = " << (double) m_cpt_minval / m_cpt_cycles << std::endl
+                << "[319] AVE. INVAL PER M_INV  = " << (double) (m_cpt_minval_local + m_cpt_minval_remote) / m_cpt_minval << std::endl
+                << "[320] AV. LOC INV PER M_INV = " << (double) m_cpt_minval_local / m_cpt_minval << std::endl
+                << "[321] AV. REM INV PER M_INV = " << (double) m_cpt_minval_remote / m_cpt_minval << std::endl
                 << std::endl
-                << "[122] INVAL BROADCAST RATE  = " << (double) m_cpt_binval / m_cpt_cycles << std::endl
-                << "[123] WRITE DIRTY RATE      = " << (double) m_cpt_write_dirty / m_cpt_cycles << std::endl
+                << "[322] INVAL BROADCAST RATE  = " << (double) m_cpt_binval / m_cpt_cycles << std::endl
+                << "[323] WRITE DIRTY RATE      = " << (double) m_cpt_write_dirty / m_cpt_cycles << std::endl
                 << std::endl
-                << "[124] CLEANUP RATE          = " << (double) (m_cpt_cleanup_local + m_cpt_cleanup_remote) / m_cpt_cycles << std::endl
-                << "[125] LOCAL CLEANUP RATE    = " << (double) m_cpt_cleanup_local / m_cpt_cycles << std::endl
-                << "[126] REMOTE CLEANUP RATE   = " << (double) m_cpt_cleanup_remote / m_cpt_cycles << std::endl
-                << "[127] LL RATE               = " << (double) (m_cpt_ll_local + m_cpt_ll_remote) / m_cpt_cycles << std::endl
-                << "[128] LOCAL LL RATE         = " << (double) m_cpt_ll_local / m_cpt_cycles << std::endl
-                << "[129] REMOTE LL RATE        = " << (double) m_cpt_ll_remote / m_cpt_cycles << std::endl
-                << "[130] SC RATE               = " << (double) (m_cpt_sc_local + m_cpt_sc_remote) / m_cpt_cycles << std::endl
-                << "[131] LOCAL SC RATE         = " << (double) m_cpt_sc_local / m_cpt_cycles << std::endl
-                << "[132] REMOTE SC RATE        = " << (double) m_cpt_sc_remote / m_cpt_cycles << std::endl
-                << "[133] CAS RATE              = " << (double) (m_cpt_cas_local + m_cpt_cas_remote) / m_cpt_cycles << std::endl
-                << "[134] LOCAL CAS RATE        = " << (double) m_cpt_cas_local / m_cpt_cycles << std::endl
-                << "[135] REMOTE CAS RATE       = " << (double) m_cpt_cas_remote / m_cpt_cycles << std::endl
+                << "[324] CLEANUP RATE          = " << (double) (m_cpt_cleanup_local + m_cpt_cleanup_remote) / m_cpt_cycles << std::endl
+                << "[325] LOCAL CLEANUP RATE    = " << (double) m_cpt_cleanup_local / m_cpt_cycles << std::endl
+                << "[326] REMOTE CLEANUP RATE   = " << (double) m_cpt_cleanup_remote / m_cpt_cycles << std::endl
+                << "[327] LL RATE               = " << (double) (m_cpt_ll_local + m_cpt_ll_remote) / m_cpt_cycles << std::endl
+                << "[328] LOCAL LL RATE         = " << (double) m_cpt_ll_local / m_cpt_cycles << std::endl
+                << "[329] REMOTE LL RATE        = " << (double) m_cpt_ll_remote / m_cpt_cycles << std::endl
+                << "[330] SC RATE               = " << (double) (m_cpt_sc_local + m_cpt_sc_remote) / m_cpt_cycles << std::endl
+                << "[331] LOCAL SC RATE         = " << (double) m_cpt_sc_local / m_cpt_cycles << std::endl
+                << "[332] REMOTE SC RATE        = " << (double) m_cpt_sc_remote / m_cpt_cycles << std::endl
+                << "[333] CAS RATE              = " << (double) (m_cpt_cas_local + m_cpt_cas_remote) / m_cpt_cycles << std::endl
+                << "[334] LOCAL CAS RATE        = " << (double) m_cpt_cas_local / m_cpt_cycles << std::endl
+                << "[335] REMOTE CAS RATE       = " << (double) m_cpt_cas_remote / m_cpt_cycles << std::endl
                 << std::endl
                 << std::endl;