Index: branches/MESI/modules/vci_cc_vcache_wrapper/caba/metadata/vci_cc_vcache_wrapper.sd
===================================================================
--- branches/MESI/modules/vci_cc_vcache_wrapper/caba/metadata/vci_cc_vcache_wrapper.sd	(revision 719)
+++ branches/MESI/modules/vci_cc_vcache_wrapper/caba/metadata/vci_cc_vcache_wrapper.sd	(revision 785)
@@ -32,5 +32,5 @@
                 parameter.Reference('addr_size'))
             ),
-			Uses('caba:dspin_dhccp_param'),
+			Uses('caba:dspin_hmesi_param'),
         ],
 
Index: branches/MESI/modules/vci_cc_vcache_wrapper/caba/source/include/vci_cc_vcache_wrapper.h
===================================================================
--- branches/MESI/modules/vci_cc_vcache_wrapper/caba/source/include/vci_cc_vcache_wrapper.h	(revision 719)
+++ branches/MESI/modules/vci_cc_vcache_wrapper/caba/source/include/vci_cc_vcache_wrapper.h	(revision 785)
@@ -35,4 +35,5 @@
 #include <inttypes.h>
 #include <systemc>
+
 #include "caba_base_module.h"
 #include "multi_write_buffer.h"
@@ -42,5 +43,5 @@
 #include "vci_initiator.h"
 #include "dspin_interface.h"
-#include "dspin_dhccp_param.h"
+#include "dspin_hmesi_param.h"
 #include "mapping_table.h"
 #include "static_assert.h"
Index: branches/MESI/modules/vci_cc_vcache_wrapper/caba/source/src/vci_cc_vcache_wrapper.cpp
===================================================================
--- branches/MESI/modules/vci_cc_vcache_wrapper/caba/source/src/vci_cc_vcache_wrapper.cpp	(revision 719)
+++ branches/MESI/modules/vci_cc_vcache_wrapper/caba/source/src/vci_cc_vcache_wrapper.cpp	(revision 785)
@@ -29,4 +29,5 @@
 
 #include <cassert>
+
 #include "arithmetics.h"
 #include "../include/vci_cc_vcache_wrapper.h"
@@ -182,4 +183,5 @@
     };
 
+#if 0 // causes compilation warnings if not used
 const char *cache_state_str[] = {
         "CACHE_SLOT_STATE_INVALID",
@@ -189,4 +191,6 @@
         "CACHE_SLOT_STATE_ZOMBI",
     };
+#endif
+
 }
 
@@ -3833,8 +3837,4 @@
                                 r_cas_local_word.read(),
                                 r_dcache_vci_cas_new.read());
-
-               //r_dcache.write_dir( r_cas_local_way.read(),
-               //                    r_cas_local_set.read(),
-               //                    CACHE_SLOT_STATE_MODIFIED );
             }
 
@@ -4323,6 +4323,6 @@
 
         uint32_t rdata;
-        size_t   way;
-        size_t   set;
+        size_t   way = 0; // To avoid g++ warning
+        size_t   set = 0; // To avoid g++ warning
         size_t   word;
         r_dcache.read_neutral(r_dcache_xtn_data_addr.read(),
@@ -5881,5 +5881,5 @@
             if ( p_vci.rspval.read() )
             {
-                if ( (p_vci.rerror.read()&0x1) != 0 )  // error reported
+                if ((p_vci.rerror.read() & 0x1) != 0)  // error reported
                 {
                     r_vci_rsp_ins_error = true;
@@ -5947,5 +5947,5 @@
             if ( p_vci.rspval.read() )
             {
-                if ( (p_vci.rerror.read()&0x1) != 0 )  // error reported
+                if ( (p_vci.rerror.read() & 0x1) != 0 )  // error reported
                 {
                     r_vci_rsp_data_error = true;
@@ -5954,6 +5954,4 @@
                 else                                        // no error reported
                 {
-
-
                     if ( r_vci_rsp_fifo_dcache.wok() )
                     {
@@ -5961,16 +5959,14 @@
                         "The VCI response packet for data miss is too long");
 
-                        r_vci_rsp_cpt                 = r_vci_rsp_cpt.read() + 1;
-                        vci_rsp_fifo_dcache_put       = true,
-                        vci_rsp_fifo_dcache_data      = p_vci.rdata.read();
-
-                        if ( p_vci.reop.read() )
+                        r_vci_rsp_cpt            = r_vci_rsp_cpt.read() + 1;
+                        vci_rsp_fifo_dcache_put  = true,
+                        vci_rsp_fifo_dcache_data = p_vci.rdata.read();
+
+                        if (p_vci.reop.read())
                         {
                             r_dcache_rsp_state = ((p_vci.rpktid.read() & 0x8) == 0x8);  // EXCLUSIVE = 0x8
-                            if (r_vci_rsp_cpt.read() != m_dcache_words - 1) std::cout << "assert on proc " << name() << std::endl;
-                            assert( (r_vci_rsp_cpt.read() == m_dcache_words - 1) and
-                            "The VCI response packet for data miss is too short");
-
-                            r_vci_rsp_fsm     = RSP_IDLE;
+                            assert( (r_vci_rsp_cpt.read() == m_dcache_words - 1) and "The VCI response packet for data miss is too short");
+
+                            r_vci_rsp_fsm = RSP_IDLE;
                         }
                     }
@@ -5987,5 +5983,5 @@
                 "illegal VCI response packet for uncachable read data");
 
-                if ( (p_vci.rerror.read()&0x1) != 0 )  // error reported
+                if ( (p_vci.rerror.read() & 0x1) != 0 )  // error reported
                 {
                     r_vci_rsp_data_error = true;
@@ -6010,5 +6006,5 @@
             if ( p_vci.rspval.read() )
             {
-                if ( (p_vci.rerror.read()&0x1) != 0 )  // error reported
+                if ( (p_vci.rerror.read() & 0x1) != 0 )  // error reported
                 {
                     r_vci_rsp_data_error = true;
@@ -6211,22 +6207,22 @@
                 uint64_t receive_data = p_dspin_m2p.data.read();
                 // initialize coherence packet type
-                uint64_t receive_type = DspinDhccpParam::dspin_get(receive_data,
-                                            DspinDhccpParam::M2P_TYPE);
+                uint64_t receive_type = DspinHmesiParam::dspin_get(receive_data,
+                                            DspinHmesiParam::M2P_TYPE);
                 // test for a broadcast
-                if (DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::M2P_BC))
+                if (DspinHmesiParam::dspin_get(receive_data,DspinHmesiParam::M2P_BC))
                 {
                     r_cc_receive_fsm = CC_RECEIVE_BRDCAST_HEADER;
                 }
                 // test for a multi updt
-                else if (receive_type == DspinDhccpParam::TYPE_MULTI_UPDT_DATA) 
+                else if (receive_type == DspinHmesiParam::TYPE_MULTI_UPDT_DATA) 
                 {
                     r_cc_receive_fsm = CC_RECEIVE_DATA_UPDT_HEADER;
                 }
-                else if (receive_type == DspinDhccpParam::TYPE_MULTI_UPDT_INST)
+                else if (receive_type == DspinHmesiParam::TYPE_MULTI_UPDT_INST)
                 {
                     r_cc_receive_fsm = CC_RECEIVE_INS_UPDT_HEADER;
                 }
                 // test for a multi inval
-                else if (receive_type == DspinDhccpParam::TYPE_MULTI_INVAL_DATA)
+                else if (receive_type == DspinHmesiParam::TYPE_MULTI_INVAL_DATA)
                 {
                     r_cc_receive_fsm = CC_RECEIVE_DATA_INVAL_HEADER;
@@ -6247,14 +6243,14 @@
                 not (r_cc_receive_dcache_req.read()))
             {
-                r_cc_receive_dcache_srcid = DspinDhccpParam::dspin_get(receive_data,
-                                            DspinDhccpParam::BROADCAST_SRCID);
-
-                r_cc_receive_dcache_inval_is_config = DspinDhccpParam::dspin_get(receive_data,
-                                                      DspinDhccpParam::BRDCAST_IS_CONFIG);
-
-                r_cc_receive_dcache_is_shared = DspinDhccpParam::dspin_get(receive_data,
-                                            DspinDhccpParam::BRDCAST_IS_SHARED);
-
-                r_cc_receive_fsm          = CC_RECEIVE_BRDCAST_NLINE;
+                r_cc_receive_dcache_srcid = DspinHmesiParam::dspin_get(receive_data,
+                                            DspinHmesiParam::BROADCAST_SRCID);
+
+                r_cc_receive_dcache_inval_is_config = DspinHmesiParam::dspin_get(receive_data,
+                                                      DspinHmesiParam::BRDCAST_IS_CONFIG);
+
+                r_cc_receive_dcache_is_shared = DspinHmesiParam::dspin_get(receive_data,
+                                            DspinHmesiParam::BRDCAST_IS_SHARED);
+
+                r_cc_receive_fsm = CC_RECEIVE_BRDCAST_NLINE;
             }
             break;
@@ -6278,11 +6274,11 @@
                 // request dcache to handle the BROADCAST
                 r_cc_receive_dcache_req = true;
-                r_cc_receive_dcache_nline  = DspinDhccpParam::dspin_get(receive_data,
-                                             DspinDhccpParam::BROADCAST_NLINE);
+                r_cc_receive_dcache_nline  = DspinHmesiParam::dspin_get(receive_data,
+                                             DspinHmesiParam::BROADCAST_NLINE);
                 r_cc_receive_dcache_type = CC_TYPE_BRDCAST;
                 // request icache to handle the BROADCAST
                 r_cc_receive_icache_req = true;
-                r_cc_receive_icache_nline  = DspinDhccpParam::dspin_get(receive_data,
-                                             DspinDhccpParam::BROADCAST_NLINE);
+                r_cc_receive_icache_nline  = DspinHmesiParam::dspin_get(receive_data,
+                                             DspinHmesiParam::BROADCAST_NLINE);
                 r_cc_receive_icache_type = CC_TYPE_INVAL;
                 // get back to idle state
@@ -6303,9 +6299,9 @@
                 // sample updt tab index in the HEADER, then skip to second flit
                 r_cc_receive_fsm = CC_RECEIVE_DATA_INVAL_NLINE;
-                r_cc_receive_dcache_inval_is_config = DspinDhccpParam::dspin_get(receive_data,
-                                                      DspinDhccpParam::MULTI_INVAL_IS_CONFIG);
-
-                r_cc_receive_dcache_is_shared = DspinDhccpParam::dspin_get(receive_data,
-                                            DspinDhccpParam::MULTI_INVAL_IS_SHARED);
+                r_cc_receive_dcache_inval_is_config = DspinHmesiParam::dspin_get(receive_data,
+                                                      DspinHmesiParam::MULTI_INVAL_IS_CONFIG);
+
+                r_cc_receive_dcache_is_shared = DspinHmesiParam::dspin_get(receive_data,
+                                            DspinHmesiParam::MULTI_INVAL_IS_SHARED);
             }
             break;
@@ -6329,5 +6325,5 @@
                 // request dcache to handle the INVAL
                 r_cc_receive_dcache_req = true;
-                r_cc_receive_dcache_nline = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_INVAL_NLINE);
+                r_cc_receive_dcache_nline = DspinHmesiParam::dspin_get(receive_data,DspinHmesiParam::MULTI_INVAL_NLINE);
                 r_cc_receive_dcache_type = CC_TYPE_INVAL;
                 // get back to idle state
@@ -6348,5 +6344,5 @@
                 // request icache to handle the INVAL
                 r_cc_receive_icache_req = true;
-                r_cc_receive_icache_nline = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_INVAL_NLINE);
+                r_cc_receive_icache_nline = DspinHmesiParam::dspin_get(receive_data,DspinHmesiParam::MULTI_INVAL_NLINE);
                 r_cc_receive_icache_type = CC_TYPE_INVAL;
                 // get back to idle state
@@ -6365,5 +6361,5 @@
             if (not r_cc_receive_dcache_req.read())
             {
-                r_cc_receive_dcache_updt_tab_idx  = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::CC_UPDT_IVT_INDEX);
+                r_cc_receive_dcache_updt_tab_idx  = DspinHmesiParam::dspin_get(receive_data,DspinHmesiParam::CC_UPDT_IVT_INDEX);
                 r_cc_receive_fsm = CC_RECEIVE_DATA_UPDT_NLINE;
                 break;
@@ -6380,5 +6376,5 @@
             if (not r_cc_receive_icache_req.read())
             {
-                r_cc_receive_icache_updt_tab_idx  = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::CC_UPDT_IVT_INDEX);
+                r_cc_receive_icache_updt_tab_idx  = DspinHmesiParam::dspin_get(receive_data,DspinHmesiParam::CC_UPDT_IVT_INDEX);
                 r_cc_receive_fsm = CC_RECEIVE_INS_UPDT_NLINE;
                 break;
@@ -6397,5 +6393,5 @@
             {
                 r_cc_receive_dcache_req = true;
-                r_cc_receive_dcache_nline  = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_UPDT_NLINE);
+                r_cc_receive_dcache_nline  = DspinHmesiParam::dspin_get(receive_data,DspinHmesiParam::MULTI_UPDT_NLINE);
                 r_cc_receive_dcache_type = CC_TYPE_UPDT;
                 // get back to idle state
@@ -6415,5 +6411,5 @@
             {
                 r_cc_receive_icache_req = true;
-                r_cc_receive_icache_nline  = DspinDhccpParam::dspin_get(receive_data,DspinDhccpParam::MULTI_UPDT_NLINE);
+                r_cc_receive_icache_nline  = DspinHmesiParam::dspin_get(receive_data,DspinHmesiParam::MULTI_UPDT_NLINE);
                 r_cc_receive_icache_type = CC_TYPE_UPDT;
                 // get back to idle state
@@ -6428,16 +6424,16 @@
     ///////////////// DSPIN CLACK interface ///////////////
     
-    uint64_t clack_type = DspinDhccpParam::dspin_get(r_dspin_clack_flit.read(),
-                                                     DspinDhccpParam::CLACK_TYPE);
-
-    size_t clack_way  = DspinDhccpParam::dspin_get(r_dspin_clack_flit.read(),
-                                                   DspinDhccpParam::CLACK_WAY);
-
-    size_t clack_set  = DspinDhccpParam::dspin_get(r_dspin_clack_flit.read(),
-                                                   DspinDhccpParam::CLACK_SET);
+    uint64_t clack_type = DspinHmesiParam::dspin_get(r_dspin_clack_flit.read(),
+                                                     DspinHmesiParam::CLACK_TYPE);
+
+    size_t clack_way  = DspinHmesiParam::dspin_get(r_dspin_clack_flit.read(),
+                                                   DspinHmesiParam::CLACK_WAY);
+
+    size_t clack_set  = DspinHmesiParam::dspin_get(r_dspin_clack_flit.read(),
+                                                   DspinHmesiParam::CLACK_SET);
 
     bool dspin_clack_get      = false;
-    bool dcache_clack_request = (clack_type == DspinDhccpParam::TYPE_CLACK_DATA);
-    bool icache_clack_request = (clack_type == DspinDhccpParam::TYPE_CLACK_INST);
+    bool dcache_clack_request = (clack_type == DspinHmesiParam::TYPE_CLACK_DATA);
+    bool icache_clack_request = (clack_type == DspinHmesiParam::TYPE_CLACK_INST);
 
     if (r_dspin_clack_req.read())
@@ -6676,13 +6672,10 @@
         {
             // initialize dspin send data
-//             DspinDhccpParam::dspin_set(dspin_send_data,
-//                                       0,
-//                                       DspinDhccpParam::P2M_EOP);
-            DspinDhccpParam::dspin_set(dspin_send_data,
+            DspinHmesiParam::dspin_set(dspin_send_data,
                                        m_cc_global_id,
-                                       DspinDhccpParam::CLEANUP_SRCID);
-            DspinDhccpParam::dspin_set(dspin_send_data,
+                                       DspinHmesiParam::CLEANUP_SRCID);
+            DspinHmesiParam::dspin_set(dspin_send_data,
                                        0,
-                                       DspinDhccpParam::P2M_BC);
+                                       DspinHmesiParam::P2M_BC);
 
             if(r_cc_send_last_client.read() == 0) // dcache active request
@@ -6690,24 +6683,24 @@
                 uint64_t dest = (uint64_t) r_dcache_cc_send_nline.read() 
                                 >> (m_nline_width - m_x_width - m_y_width) 
-                                << (DspinDhccpParam::GLOBALID_WIDTH - m_x_width - m_y_width);
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                << (DspinHmesiParam::GLOBALID_WIDTH - m_x_width - m_y_width);
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            dest,
-                                           DspinDhccpParam::CLEANUP_DEST);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinHmesiParam::CLEANUP_DEST);
+
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            (r_dcache_cc_send_nline.read() & 0x300000000ULL)>>32,
-                                           DspinDhccpParam::CLEANUP_NLINE_MSB);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinHmesiParam::CLEANUP_NLINE_MSB);
+
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            r_dcache_cc_send_way.read(),
-                                           DspinDhccpParam::CLEANUP_WAY_INDEX);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
-                                           DspinDhccpParam::TYPE_CLEANUP_DATA,
-                                           DspinDhccpParam::P2M_TYPE);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinHmesiParam::CLEANUP_WAY_INDEX);
+
+                DspinHmesiParam::dspin_set(dspin_send_data,
+                                           DspinHmesiParam::TYPE_CLEANUP_DATA,
+                                           DspinHmesiParam::P2M_TYPE);
+
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            (r_dcache_cc_line_no_shared.read() and (r_cc_send_last_client.read() == 0) and not r_dcache_cc_send_inval_is_config.read()),
-                                           DspinDhccpParam::DATA_NO_SHARED);
+                                           DspinHmesiParam::DATA_NO_SHARED);
             }
             else                                // icache active request
@@ -6715,25 +6708,25 @@
                 uint64_t dest = (uint64_t) r_icache_cc_send_nline.read() 
                                 >> (m_nline_width - m_x_width - m_y_width) 
-                                << (DspinDhccpParam::GLOBALID_WIDTH - m_x_width - m_y_width);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                << (DspinHmesiParam::GLOBALID_WIDTH - m_x_width - m_y_width);
+
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            dest,
-                                           DspinDhccpParam::CLEANUP_DEST);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinHmesiParam::CLEANUP_DEST);
+
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            (r_icache_cc_send_nline.read() & 0x300000000ULL)>>32,
-                                           DspinDhccpParam::CLEANUP_NLINE_MSB);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinHmesiParam::CLEANUP_NLINE_MSB);
+
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            r_icache_cc_send_way.read(),
-                                           DspinDhccpParam::CLEANUP_WAY_INDEX);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
-                                           DspinDhccpParam::TYPE_CLEANUP_INST,
-                                           DspinDhccpParam::P2M_TYPE);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinHmesiParam::CLEANUP_WAY_INDEX);
+
+                DspinHmesiParam::dspin_set(dspin_send_data,
+                                           DspinHmesiParam::TYPE_CLEANUP_INST,
+                                           DspinHmesiParam::P2M_TYPE);
+
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            0,
-                                           DspinDhccpParam::DATA_NO_SHARED);
+                                           DspinHmesiParam::DATA_NO_SHARED);
 
 
@@ -6751,13 +6744,13 @@
             if(r_cc_send_last_client.read() == 0) // dcache active request
             {
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            r_dcache_cc_send_nline.read() & 0xFFFFFFFFULL,
-                                           DspinDhccpParam::CLEANUP_NLINE_LSB);
+                                           DspinHmesiParam::CLEANUP_NLINE_LSB);
             }
             else                                  // icache active request
             {
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            r_icache_cc_send_nline.read() & 0xFFFFFFFFULL,
-                                           DspinDhccpParam::CLEANUP_NLINE_LSB);
+                                           DspinHmesiParam::CLEANUP_NLINE_LSB);
             }
             // send flit
@@ -6770,7 +6763,7 @@
         case CC_SEND_DATA_UPDT:
         {
-            DspinDhccpParam::dspin_set(dspin_send_data,
+            DspinHmesiParam::dspin_set(dspin_send_data,
                                        r_cc_send_data_fifo.read(),
-                                       DspinDhccpParam::CLEANUP_DATA_UPDT);
+                                       DspinHmesiParam::CLEANUP_DATA_UPDT);
             
             p_dspin_p2m.data = dspin_send_data;
@@ -6784,10 +6777,10 @@
         {
             // initialize dspin send data
-            DspinDhccpParam::dspin_set(dspin_send_data,
+            DspinHmesiParam::dspin_set(dspin_send_data,
                                        0,
-                                       DspinDhccpParam::P2M_BC);
-            DspinDhccpParam::dspin_set(dspin_send_data,
-                                       DspinDhccpParam::TYPE_MULTI_ACK,
-                                       DspinDhccpParam::P2M_TYPE);
+                                       DspinHmesiParam::P2M_BC);
+            DspinHmesiParam::dspin_set(dspin_send_data,
+                                       DspinHmesiParam::TYPE_MULTI_ACK,
+                                       DspinHmesiParam::P2M_TYPE);
 
             if(r_cc_send_last_client.read() == 0) // dcache active request
@@ -6795,17 +6788,17 @@
                 uint64_t dest = (uint64_t) r_dcache_cc_send_nline.read() 
                                 >> (m_nline_width - m_x_width - m_y_width) 
-                                << (DspinDhccpParam::GLOBALID_WIDTH - m_x_width - m_y_width);
+                                << (DspinHmesiParam::GLOBALID_WIDTH - m_x_width - m_y_width);
  
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            dest,
-                                           DspinDhccpParam::MULTI_ACK_DEST);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinHmesiParam::MULTI_ACK_DEST);
+
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            r_dcache_cc_send_multi_ack_miss.read(),
-                                           DspinDhccpParam::MULTI_ACK_UPDT_MISS);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinHmesiParam::MULTI_ACK_UPDT_MISS);
+
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            r_dcache_cc_send_updt_tab_idx.read(),
-                                           DspinDhccpParam::MULTI_ACK_UPDT_INDEX);
+                                           DspinHmesiParam::MULTI_ACK_UPDT_INDEX);
             }
             else                                    // icache active request
@@ -6813,13 +6806,13 @@
                 uint64_t dest = (uint64_t) r_icache_cc_send_nline.read() 
                                 >> (m_nline_width - m_x_width - m_y_width) 
-                                << (DspinDhccpParam::GLOBALID_WIDTH - m_x_width - m_y_width);
+                                << (DspinHmesiParam::GLOBALID_WIDTH - m_x_width - m_y_width);
  
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            dest,
-                                           DspinDhccpParam::MULTI_ACK_DEST);
-
-                DspinDhccpParam::dspin_set(dspin_send_data,
+                                           DspinHmesiParam::MULTI_ACK_DEST);
+
+                DspinHmesiParam::dspin_set(dspin_send_data,
                                            r_icache_cc_send_updt_tab_idx.read(),
-                                           DspinDhccpParam::MULTI_ACK_UPDT_INDEX);
+                                           DspinHmesiParam::MULTI_ACK_UPDT_INDEX);
             }
             // send flit
@@ -6913,10 +6906,10 @@
 
 
-    int clack_type = DspinDhccpParam::dspin_get(r_dspin_clack_flit.read(),
-                                                DspinDhccpParam::CLACK_TYPE);
+    int clack_type = DspinHmesiParam::dspin_get(r_dspin_clack_flit.read(),
+                                                DspinHmesiParam::CLACK_TYPE);
 
     bool dspin_clack_get      = false;
-    bool dcache_clack_request = (clack_type == DspinDhccpParam::TYPE_CLACK_DATA);
-    bool icache_clack_request = (clack_type == DspinDhccpParam::TYPE_CLACK_INST);
+    bool dcache_clack_request = (clack_type == DspinHmesiParam::TYPE_CLACK_DATA);
+    bool icache_clack_request = (clack_type == DspinHmesiParam::TYPE_CLACK_INST);
 
     if (r_dspin_clack_req.read())