Index: soft/giet_vm/applications/rosenfeld/src/ecc_main_rosenfeld_sa.c
===================================================================
--- soft/giet_vm/applications/rosenfeld/src/ecc_main_rosenfeld_sa.c	(revision 777)
+++ soft/giet_vm/applications/rosenfeld/src/ecc_main_rosenfeld_sa.c	(revision 791)
@@ -92,14 +92,14 @@
     init_forme_boulon1(&X0, &i0, &i1, &j0, &j1);
 
-    // allocatin memoire
+    // allocation memoire
     X   = ui8matrix (i0-border, i1+border, j0-border, j1+border);
     E8  = ui8matrix (i0-border, i1+border, j0-border, j1+border);
     E32 = ui32matrix(i0-border, i1+border, j0-border, j1+border);
-    
-    // initialisation de la memoir
+ 
+    // initialisation de la memoire
     zero_ui32matrix(E32, i0-border, i1+border, j0-border, j1+border);
     zero_ui8matrix (E8,  i0-border, i1+border, j0-border, j1+border);
     zero_ui8matrix (X,   i0-border, i1+border, j0-border, j1+border);
-    
+
     // pre-traitements
     binarisation_ui8matrix(X0, i0, i1, j0, j1, 1, 1, X);    // pour le traitement
@@ -182,5 +182,5 @@
     int na;
     
-    RegionStats *Stats = NULL;
+    RegionStats * Stats = NULL;
 
     RGBQuad palette[256];
@@ -191,26 +191,28 @@
 
     // chargement d'une image depuis le disque
-    X0 = LoadPGM_ui8matrix(complete_filename, &i0, &i1, &j0, &j1);
-    
-    // allocatin memoire
-    X   = ui8matrix (i0-border, i1+border, j0-border, j1+border);
-    E8  = ui8matrix (i0-border, i1+border, j0-border, j1+border);
-    E32 = ui32matrix(i0-border, i1+border, j0-border, j1+border); 
-
-    // initialisation de la memoir
-    zero_ui32matrix(E32, i0-border, i1+border, j0-border, j1+border);
-    zero_ui8matrix (E8,  i0-border, i1+border, j0-border, j1+border);
-    zero_ui8matrix (X,   i0-border, i1+border, j0-border, j1+border);
+    //X0 = LoadPGM_ui8matrix(complete_filename, &i0, &i1, &j0, &j1);
+    init_forme_boulon1(&X0, &i0, &i1, &j0, &j1);
+    
+    // allocation memoire
+    X   = ui8matrix (i0 - border, i1 + border, j0 - border, j1 + border);
+    E8  = ui8matrix (i0 - border, i1 + border, j0 - border, j1 + border);
+    E32 = ui32matrix(i0 - border, i1 + border, j0 - border, j1 + border); 
+
+    // initialisation de la memoire
+    zero_ui32matrix(E32, i0 - border, i1 + border, j0 - border, j1 + border);
+    zero_ui8matrix (E8,  i0 - border, i1 + border, j0 - border, j1 + border);
+    zero_ui8matrix (X,   i0 - border, i1 + border, j0 - border, j1 + border);
 
     // pre-traitements
     binarisation_ui8matrix(X0, i0, i1, j0, j1, 20, 1, X); // pour le traitement
-    binarisation_ui8matrix(X0, i0, i1, j0, j1, 20, 255, X0); // pour la verif visuelle
-    generate_path_filename(pathDst, "verif.pgm", complete_filename, 1024);
-    SavePGM_ui8matrix(X0, i0, i1, j0, j1, complete_filename);
-
-    height = i1-i0+1; width = j1-j0+1; 
-    
-    nemax = ((height+1)*(width+1)) / 2; // majorant strict
-    nermax = (width+1) / 2;
+    //binarisation_ui8matrix(X0, i0, i1, j0, j1, 20, 255, X0); // pour la verif visuelle
+    //generate_path_filename(pathDst, "verif.pgm", complete_filename, 1024);
+    //SavePGM_ui8matrix(X0, i0, i1, j0, j1, complete_filename);
+
+    height = i1 - i0 + 1;
+    width  = j1 - j0 + 1;
+    
+    nemax = ((height + 1) * (width + 1)) / 2; // majorant strict
+    nermax = (width + 1) / 2;
     
     // alloc init des tables d'equivalences pour UF, Suzuki et Bailey
@@ -234,8 +236,8 @@
     na = Rosenfeld_UF_Org1_8C(X, height, width, E32, T, A, nemax, Stats);
     printf("na = %d\n", na);
-    filename = "Rosenfeld_UF_Org1_8C.bmp";
+    //filename = "Rosenfeld_UF_Org1_8C.bmp";
     mod_ui32matrix_ui8matrix(E32, i0, i1, j0, j1, E8);
-    generate_path_filename(pathDst, filename, complete_filename, 1024);
-    SaveBMP2_ui8matrix(E8, width, height, palette, complete_filename);
+    //generate_path_filename(pathDst, filename, complete_filename, 1024);
+    //SaveBMP2_ui8matrix(E8, width, height, palette, complete_filename);
     zero_ui32matrix(E32, i0 - border, i1 + border, j0 - border, j1 + border);
     display_RegionStatsVector(Stats, 1, na, "Stats");
@@ -313,4 +315,7 @@
 // -----------------------------
 {
+#if TARGET_OS==GIET_VM
+    giet_tty_alloc(1);
+#endif
     display_arg(argc, argv);
     ecc_info_define();